<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Lucky Dice Casino</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <style>
        .container-fluid {
            background-image: url(LuckyDiceImagesv2023Feb/cover.jpg);
            min-height: 100px;
            margin: 5px;
        }
    </style>

</head>

<body>
    <div class="container-fluid"></div>
    <div class="container">
        <div class="row">
            <div class="col-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Your Information:</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input class="form-control" id="inp-username">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8">
                        <input class="form-control" id="inp-firstname">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8">
                        <input class="form-control" id="inp-lastname">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <button class="btn btn-success w-75" onclick="diceClick()">DICE</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img src="LuckyDiceImagesv2023Feb/dice.png" class="img-thumbnail" id="img-dice">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-message"></p>
                    </div>
                </div>
            </div>
            <div class="col-3 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <p>Voucher:</p>
                        <p id="p-voucherid">No ID</p>
                        <p id="p-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img src="" class="img-thumbnail" id="img-prize">
                    </div>
                </div>
            </div>
        </div>
        <div class="row text-center form-group">
            <div class="col-12">
                <button class="btn btn-info w-25" onclick="diceHistoryClick()">Dice History</button>
                <button class="btn btn-info w-25" onclick="voucherHistoryClick()">Voucher History</button>
                <button class="btn btn-info w-25" onclick="voucherPrizeClick()">Prize History</button>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <table class="table table-striped table-hover border" id="tab-history">
                    <tr>
                        <th class="border">Game</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td class="border">1</td>
                        <td>3</td>
                    </tr>
                    <tr>
                        <td class="border">2</td>
                        <td>6</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>

<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

    function diceClick() {
        var player = getDataForm();
        if (checkPlayerInfo(player)) {
            var request = new XMLHttpRequest();
            apiToDice(request, player);

            request.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(this.responseText);
                    var responseObj = JSON.parse(this.responseText);
                    displayDice(responseObj);
                }
            }
        }
    }

    function diceHistoryClick() {
        var player = getDataForm();
        if (checkPlayerInfo(player)) {
            var request = new XMLHttpRequest();
            apiDiceHistory(request, player.username);

            request.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(this.responseText);
                    var responseObj = JSON.parse(this.responseText);
                    displayDicesTable(responseObj.dices);
                }
            }
        }
    }

    function voucherHistoryClick() {
        var player = getDataForm();
        if (checkPlayerInfo(player)) {
            var request = new XMLHttpRequest();
            apiVoucherHistory(request, player.username);

            request.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(this.responseText);
                    var responseObj = JSON.parse(this.responseText);
                    displayVouchersTable(responseObj.vouchers);
                }
            }
        }
    }

    function voucherPrizeClick() {
        var player = getDataForm();
        if (checkPlayerInfo(player)) {
            var request = new XMLHttpRequest();
            apiPrizeHistory(request, player.username);

            request.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(this.responseText);
                    var responseObj = JSON.parse(this.responseText);
                    displayPrizesTable(responseObj.prizes);
                }
            }
        }
    }

    function getDataForm() {
        var player = {
            username: "",
            firstname: "",
            lastname: ""
        };

        var eUsername = document.getElementById("inp-username");
        var eFirstname = document.getElementById("inp-firstname");
        var eLastname = document.getElementById("inp-lastname");

        player.username = eUsername.value.trim();
        player.firstname = eFirstname.value.trim();
        player.lastname = eLastname.value.trim();

        return player;
    }

    function checkPlayerInfo(player) {
        if (player.username == "" || player.firstname == "" || player.lastname == "") {
            alert("Your informations is blank !!!");
            return false;
        }

        return true;
    }

    function apiToDice(request, player) {
        request.open("POST", vBASE_URL + "/dice", true);
        request.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        request.send(JSON.stringify(player));
    }

    function apiDiceHistory(request, username) {
        request.open("GET", vBASE_URL + "/dice-history?username=" + username, true);
        request.send();
    }

    function apiVoucherHistory(request, username) {
        request.open("GET", vBASE_URL + "/voucher-history?username=" + username, true);
        request.send();
    }

    function apiPrizeHistory(request, username) {
        request.open("GET", vBASE_URL + "/prize-history?username=" + username, true);
        request.send();
    }

    function displayDice(response) {
        var vDice = response.dice;
        var imageDice = document.getElementById("img-dice");
        imageDice.src = "LuckyDiceImagesv2023Feb/" + vDice + ".png";

        var pMessage = document.getElementById("p-message");
        if (vDice == 6) {
            pMessage.innerText = "!!! CONGRATULATION !!!";
            pMessage.style.color = "red";
        }
        else if (vDice == 5 || vDice == 4) {
            pMessage.innerText = "!!! Fightingggggg !!!";
            pMessage.style.color = "orange";
        }
        else {
            pMessage.innerText = "!!! Never Give Up !!!";
            pMessage.style.color = "blue";
        }

        var pVoucherId = document.getElementById("p-voucherid");
        var pPercent = document.getElementById("p-percent");
        if (response.voucher != null) {
            pVoucherId.innerHTML = response.voucher.maVoucher;
            pPercent.innerHTML = response.voucher.phanTramGiamGia + "%";
        }
        else {
            pVoucherId.innerHTML = "No ID";
            pPercent.innerHTML = "0%";
        }

        var imagePrize = document.getElementById("img-prize");
        if (response.prize != null)
            imagePrize.src = "LuckyDiceImagesv2023Feb/" + response.prize + ".jpg";
        else
            imagePrize.src = "LuckyDiceImagesv2023Feb/no-present.jpg";
    }

    function displayDicesTable(response) {
        var tabHistory = document.getElementById("tab-history");
        while (tabHistory.rows.length > 0)
            tabHistory.deleteRow(0);

        let newRow = tabHistory.insertRow(0);
        let newCell0 = newRow.insertCell(0);
        let newCell1 = newRow.insertCell(1);
        newCell0.innerText = "Game";
        newCell1.innerHTML = "Dice";

        for (let index = 0; index < response.length; index++) {
            let newRow = tabHistory.insertRow(1);
            let newCell0 = newRow.insertCell(0);
            let newCell1 = newRow.insertCell(1);
            newCell0.innerText = index + 1;
            newCell1.innerHTML = response[index];
        }
    }

    function displayVouchersTable(response) {
        var tabHistory = document.getElementById("tab-history");
        while (tabHistory.rows.length > 0)
            tabHistory.deleteRow(0);

        let newRow = tabHistory.insertRow(0);
        let newCell0 = newRow.insertCell(0);
        let newCell1 = newRow.insertCell(1);
        newCell0.innerText = "Voucher";
        newCell1.innerHTML = "Discount";

        for (let index = 0; index < response.length; index++) {
            let newRow = tabHistory.insertRow(1);
            let newCell0 = newRow.insertCell(0);
            let newCell1 = newRow.insertCell(1);
            newCell0.innerText = response[index].maVoucher;
            newCell1.innerHTML = response[index].phanTramGiamGia;
        }
    }

    function displayPrizesTable(response) {
        var tabHistory = document.getElementById("tab-history");
        while (tabHistory.rows.length > 0)
            tabHistory.deleteRow(0);

        let newRow = tabHistory.insertRow(0);
        let newCell0 = newRow.insertCell(0);
        let newCell1 = newRow.insertCell(1);
        newCell0.innerText = "No";
        newCell1.innerHTML = "Prize";

        for (let index = 0; index < response.length; index++) {
            let newRow = tabHistory.insertRow(1);
            let newCell0 = newRow.insertCell(0);
            let newCell1 = newRow.insertCell(1);
            newCell0.innerText = index + 1;
            newCell1.innerHTML = response[index];
        }
    }

</script>

</html>